<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { ProModal } from 'antdv-pro-modal';
import { message } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import { listUEInfoBySMF } from '@/api/neUser/smf';
import useNeInfoStore from '@/store/modules/neinfo';
import useI18n from '@/hooks/useI18n';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import TableColumnsDnd from '@/components/TableColumnsDnd/index.vue';
import useUserStore from '@/store/modules/user';

const { t } = useI18n();

/**网元参数 */
let neOtions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**所有SMF */
  totalType: <Record<string, any>[]>[],
  /**网元ID */
  neId: undefined,
  /**IMSI */
  imsi: '',
  /**msisdn */
  msisdn: '',

  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 200,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    imsi: '',
    msisdn: '',
    pageNum: 1,
    pageSize: 200,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetAllList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: 'IMSI',
    dataIndex: 'imsi',
    align: 'center',
    sorter: (a: any, b: any) => Number(a.imsi) - Number(b.imsi),
    customRender(opt) {
      const idx = opt.value.lastIndexOf('-');
      if (idx != -1) {
        return opt.value.substring(idx + 1);
      }
      return opt.value;
    },
    width: 150,
  },
  {
    title: 'MSISDN',
    dataIndex: 'msisdn',
    align: 'center',
    sorter: (a: any, b: any) => Number(a.msisdn) - Number(b.msisdn),
    customRender(opt) {
      const idx = opt.value.lastIndexOf('-');
      if (idx != -1) {
        return opt.value.substring(idx + 1);
      }
      return opt.value;
    },
    width: 150,
  },
  {
    title: 'RAT Type',
    dataIndex: 'ratType',
    align: 'center',
    width: 100,
  },
  {
    title: 'APN/DNN List',
    dataIndex: 'pduSessionInfo',
    align: 'left',
    customRender(opt) {
      if (opt.value) {
        let arr = [];
        for (const v of opt.value) {
          if (v.dnn) {
            arr.push(v.dnn);
          }
        }
        return arr.sort().join(',');
      }
      return '';
    },
    width: 150,
  },
  {
    title: t('common.operate'),
    key: 'imsi',
    align: 'left',
  },
];

/**表格字段列排序 */
let tableColumnsDnd = ref<ColumnsType>([]);

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetAllList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**详情框是否显示 */
  visibleByView: boolean;
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByView: false,
  visibleByEdit: false,
  title: '在线信息',
  from: {
    imsi: '',
    msisdn: '',
    pduSessionInfo: undefined,
    ratType: '',
  },
  confirmLoading: false,
});

/**
 * 对话框弹出显示为 查看
 * @param row 单行记录信息
 */
function fnModalVisibleByVive(row: Record<string, any>) {
  if (!row.imsi) {
    message.error(t('common.getInfoFail'), 2);
    return;
  }
  const imsiIdx = row.imsi.lastIndexOf('-');
  if (imsiIdx != -1) {
    row.imsi = row.imsi.substring(imsiIdx + 1);
  }
  const msisdnIdx = row.msisdn.lastIndexOf('-');
  if (msisdnIdx != -1) {
    row.msisdn = row.msisdn.substring(msisdnIdx + 1);
  }
  modalState.from = Object.assign(modalState.from, row);
  modalState.title = `${row.imsi}`;
  modalState.visibleByView = true;
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByEdit = false;
  modalState.visibleByView = false;
}

//接收响应信息
let promises = ref<any[]>([]);

/**查询列表, pageNum初始页数 */
function fnGetAllList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }

  tableState.data = [];
  promises.value = [];

  //同时获取45G基站信息 且在每条信息中添加45G字段(原始数据没有) 已经筛选后的
  queryParams.totalType.map((item: any) => {
    promises.value.push(
      listUEInfoBySMF({
        neId: item.neId,
        imsi: queryParams.imsi,
        msisdn: queryParams.msisdn,
        pageNum: queryParams.pageNum,
        pageSize: 10000,
      })
    );
  });

  Promise.allSettled(promises.value).then(results => {
    results.forEach(result => {
      if (result.status === 'fulfilled') {
        const allUeData = result.value;
        if (
          allUeData.code === RESULT_CODE_SUCCESS &&
          Array.isArray(allUeData.rows)
        ) {
          // 处理成功结果
          tablePagination.total += allUeData.total;
          tableState.data = [...tableState.data, ...allUeData.rows];
          if (
            tablePagination.total <=
              (queryParams.pageNum - 1) * tablePagination.pageSize &&
            queryParams.pageNum !== 1
          ) {
            tableState.loading = false;
            fnGetAllList(queryParams.pageNum - 1);
          }
        } else {
          tablePagination.total = 0;
          tableState.data = [];
        }
        tableState.loading = false;
      }
    });
  });
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          let arr: Record<string, any>[] = [];
          res.data.forEach(i => {
            if (i.neType === 'SMF') {
              arr.push({ value: i.neId, label: i.neName });
              queryParams.totalType.push(i);
            }
          });

          neOtions.value = arr;
          if (arr.length > 0) {
            queryParams.neId = arr[0].value;
          }
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetAllList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item label="IMSI" name="imsi">
              <a-input v-model:value="queryParams.imsi" allow-clear></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item label="MSISDN" name="msisdn">
              <a-input v-model:value="queryParams.msisdn" allow-clear></a-input>
            </a-form-item>
          </a-col>

          <a-col :lg="8" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetAllList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title> </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetAllList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <TableColumnsDnd
            cache-id="ueData"
            :columns="tableColumns"
            v-model:columns-dnd="tableColumnsDnd"
          ></TableColumnsDnd>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumnsDnd"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: 1000, y: 400 }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'imsi'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.viewText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByVive(record)"
                >
                  <template #icon><ProfileOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 详情框 -->
    <ProModal
      :width="800"
      :open="modalState.visibleByView"
      :title="modalState.title"
      @cancel="fnModalCancel"
      :footer="null"
    >
      <a-form layout="horizontal" labelAlign="left" :labelWrap="false">
        <a-row>
          <a-col :lg="8" :md="8" :xs="24">
            <a-form-item label="IMSI" name="imsi">
              {{ modalState.from.imsi }}
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="8" :xs="24">
            <a-form-item label="MSISDN" name="msisdn">
              {{ modalState.from.msisdn }}
            </a-form-item>
          </a-col>
          <a-col :lg="8" :md="8" :xs="24">
            <a-form-item label="RAT Type" name="ratType">
              {{ modalState.from.ratType }}
            </a-form-item>
          </a-col>
        </a-row>

        <a-descriptions
          :title="v.dnn"
          :column="2"
          size="small"
          bordered
          v-for="v in modalState.from.pduSessionInfo"
          :key="v.dnn"
        >
          <a-descriptions-item label="PDU Session ID">
            {{ v.pduSessionID }}
          </a-descriptions-item>
          <a-descriptions-item label="User Plane State">
            {{ v.upState }}
          </a-descriptions-item>
          <a-descriptions-item label="IPV4">{{ v.ipv4 }}</a-descriptions-item>
          <a-descriptions-item label="IPV6">{{ v.ipv6 }}</a-descriptions-item>
          <a-descriptions-item label="TAI">{{ v.tai }}</a-descriptions-item>
          <a-descriptions-item label="SST-SD">
            {{ v.sstSD }}</a-descriptions-item
          >
          <a-descriptions-item label="UPF N3 IP">
            {{ v.upfN3IP }}
          </a-descriptions-item>
          <a-descriptions-item label="RAN N3 IP">
            {{ v.ranN3IP }}
          </a-descriptions-item>
          <a-descriptions-item label="Create Time">
            {{ v.activeTime }}
          </a-descriptions-item>
        </a-descriptions>
      </a-form>
    </ProModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
